<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper non-table">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="6" class="text-align-left">
                            <h3>User Histories</h3>
                        </el-col>
                        <el-col :span="18">
                            <el-row :gutter="20">
                                <el-col :lg="7" :md="7" :sm="24">
                                    <el-select
                                        ref="user"
                                        name="user"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getUsers"
                                        v-model="filter.user"
                                        value-key="id"
                                        placeholder="Type usename"
                                        no-data-text="No Record Found"
                                        :loading="userLoading"
                                        @clear="filterUserClear()">
                                        <el-option
                                            v-for="item in users"
                                            :key="item.id"
                                            :label="item.fullname"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.fullname }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.role.name }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-col>
                                <el-col :lg="12" :md="12" :sm="24">
                                    <el-date-picker
                                        prop="daterange"
                                        ref="daterange"
                                        name="daterange"
                                        v-model="filter.daterange"
                                        type="daterange"
                                        align="right"
                                        unlink-panels
                                        range-separator="-"
                                        start-placeholder="Start date"
                                        end-placeholder="End date"
                                        :clearable="true" 
                                        :editable="false">
                                    </el-date-picker>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getHistories(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>            
                </div>
                <div class="block text-align-left" v-loading="historyLoading" style="height:100%;">
                    <el-timeline v-if="histories.length > 0" v-infinite-scroll="loadMore">
                        <el-timeline-item
                            v-for="(history, index) in histories"
                            :key="index" 
                            :timestamp="dateFormat(history.created)" 
                            placement="top">
                            <el-card>
                                <h4>{{ history.user.fullname }} - {{ history.action }} {{ history.module }}</h4>
                                <p>{{ history.user_agent.os.family }} {{ history.user_agent.os.major }} {{ history.user_agent.user_agent.family }} - {{ history.remote_address }}</p>
                                <code v-if="Object.keys(history.content).length > 0">{{ JSON.stringify(history.content, null, 4) }}</code>
                            </el-card>
                        </el-timeline-item>                        
                    </el-timeline>
                    <el-row v-else :gutter="20" type="flex" justify="center" align="middle" :style="`height:${tableHeight()}px;`">
                        <el-col :lg="24" :md="24" :sm="24" align="middle">
                            <div class="no-content text-align-center">
                                <i class="ion-ios-time" style="font-size:100px;color:#909399;"></i>
                                <span class="display-block">No Histories Recorded</span>
                            </div>
                        </el-col>
                    </el-row>
                </div>
            </el-col>
        </el-row>
    </div>
</template>

<script>
import { mapGetters } from 'vuex';
import { dateFormat, tableHeight } from '../../utils/index';
export default {
    name: 'Histories',
    data(){
        return{
            historyLoading: true,
            userLoading: false,
            filter: {
                daterange: null,
                user: null
            }
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('user', ['users']),
        ...mapGetters('history', [
            'histories',
            'pagination'
        ])  
    },
    created(){
        const self = this;
        self.getHistories(1, false);
    },
    methods: {
        dateFormat,
        tableHeight,
        getUsers(q){
            const self = this;

            if(q.length >= 3){
                self.userLoading = true;
                self.$store.dispatch('user/getUsers', {
                    q: q,
                    page: 1,
                    perpage: 25
                }).then(() => {
                    self.userLoading = false;
                });
            }
        },
        getHistories(page, loadmore){
            const self = this;

            self.historyLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore,
                only: 'action,content,module,remote_address,created,user.fullname,user_agent'
            };

            if(self.filter.daterange != null){
                params.daterange = self.filter.daterange.map((x)=>dateFormat(x, 'YYYY-MM-DD')).join(',');
            }

            if(self.filter.user != null){
                params.user = parseInt(self.filter.user);
            }

            self.$store.dispatch('history/getHistories', params).then(()=>{
                self.historyLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getHistories(self.pagination.page + 1, true);
            }
        },
        filterUserClear(){
            const self = this;
            self.filter.user = null;
            self.$store.dispatch('user/resetUsers');
        }
    },
    
}
</script>